package com.pokkt.demo.activities;

import android.Manifest;
import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v4.content.FileProvider;
import android.view.KeyEvent;
import android.view.Window;

import com.pokkt.ad.demo.R;

import java.io.File;

public class SplashActivity extends Activity {

    boolean isClosed = false;

    Handler handler = new Handler();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_splash);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            if (ContextCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED) {
                // No explanation needed, we can request the permission.
                ActivityCompat.requestPermissions(this,
                        new String[]{
                                Manifest.permission.WRITE_EXTERNAL_STORAGE,
                                Manifest.permission.WRITE_CALENDAR,
                                Manifest.permission.ACCESS_COARSE_LOCATION,
                                Manifest.permission.CALL_PHONE,
                                Manifest.permission.SEND_SMS,
                        }, 1);
            } else {
                redirectMenuScreen();
            }
        } else {
            redirectMenuScreen();
        }
    }

    private void testShare() {
        String imageFile = Environment.getExternalStorageDirectory()
                + File.separator + "Tata.jpg";
        Uri imageFileURI = Uri.fromFile(new File("/storage/emulated/0/Tata.jpg"));

        File imagePath = new File(String.valueOf(Environment.getExternalStorageDirectory()));
        File newFile = new File(imagePath, "Tata.jpg");
        Uri contentUri = FileProvider.getUriForFile(this, getPackageName()+".fileprovider", newFile);
        //imageFileURI = FileProvider.getUriForFile(getApplicationContext(), getPackageName()+".fileprovider", new File("/storage/emulated/0/Tata.jpg"));

        Intent intent = new Intent(Intent.ACTION_SEND);
        intent.setType("text/plain");
        String message="File to be shared is " + "tata" + ".";
        intent.putExtra(Intent.EXTRA_SUBJECT, "Subject");
        intent.putExtra(Intent.EXTRA_STREAM, contentUri);
        //intent.putExtra(Intent.EXTRA_TEXT, message);
        //intent.setData(Uri.parse("mailto:xyz@gmail.com"));
        intent.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);

        startActivity(intent);
//        String sharedData = "intent:#Intent;action=android.intent.action.SEND;type=text/plain;S.android.intent.extra.TEXT=https%3A%2F%2Fpaul.kinlan.me%2F;S.android.intent.extra.SUBJECT=Amazing;S.browser_fallback_url=https:%3A%2F%2Ftwitter.com%2Fintent%2Ftweet;S.android.intent.extra.STREAM=;end";
//        Intent intent = null;
//        try {
//            intent = Intent.parseUri(sharedData, Intent.URI_INTENT_SCHEME);
//            if (intent != null && intent.resolveActivity(getPackageManager()) != null) {
//                startActivityForResult(intent, 100);
//            } else {
//                Logger.i("Invalid Image card Follow Up Action!");
//            }
//        } catch (URISyntaxException e) {
//            Logger.printStackTrace(e.getMessage(), e);
//        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        switch (requestCode) {
            case 1: {
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

                    // permission was granted, yay! Do the
                    // contacts-related task you need to do.

                } else {

                    // permission denied, boo! Disable the
                    // functionality that depends on this permission.
                }
                redirectMenuScreen();
                return;
            }

            // other 'case' lines to check for other
            // permissions this app might request
        }
    }


    void redirectMenuScreen() {
        handler.postDelayed(new Runnable() {
            public void run() {
                if (!isClosed) {
                    Intent intent = new Intent(getBaseContext(), MainActivity.class);
                    intent.addFlags(Intent.FLAG_ACTIVITY_BROUGHT_TO_FRONT);//IF app is launched from pokkt notification and app is in background
                    startActivity(intent);
                    finish();
                }
            }
        }, 500);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            isClosed = true;
            finish();
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
    }
}
